#include "lubeapp.h"

extern void LED_Process();

void RunLubeApp(volatile uint32_t *wheelPulseCounter)
{
    uint32_t LubeDistance = 0;
    static uint32_t lubePulseTimestamp = 0;
    // Calculate traveled Distance in mm
    TravelDistance_highRes += (*wheelPulseCounter * LubeConfig.DistancePerRevolution_mm);
    *wheelPulseCounter = 0;

    // check if we have to Lube!
    switch (globals.systemStatus)
    {
    case sysStat_Normal:
        LubeDistance = LubeConfig.DistancePerLube_Default;
        break;
    case sysStat_Rain:
        LubeDistance = LubeConfig.DistancePerLube_Rain;
        break;
    }

    if (TravelDistance_highRes > LubeDistance){
        lubePulseTimestamp = millis() + LUBE_PULSE_LENGHT_MS;
        TravelDistance_highRes = 0;
    }

    //maintain Pin-State of Lube-Pump
    if (lubePulseTimestamp > millis())
        digitalWrite(GPIO_PUMP, HIGH);
    else
        digitalWrite(GPIO_PUMP, LOW);
}
